<?php

/**
 * comision actions.
 *
 * @package    controlComisiones
 * @subpackage comision
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class comisionActions extends sfQuery {
    
    public $conn;
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_COMISION',
        'PROYECTOS',
        'TIPOS_COMISION',
        'AREA',
        'COM_TIPO_DESTINO',
        'COM_TIPO_VIATICO',
        'COM_ESTADO_RAD'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'AREA' =>
        array(
            'id_area' => 'COM_COMISION'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'id_tipo_destino' => 'COM_COMISION'
        ),
        'COM_TIPO_VIATICO' =>
        array(
            'id_tipo_viatico' => 'COM_COMISION'
        ),
        'COM_ESTADO_RAD' =>
        array(
            'id_comision' => 'COM_COMISION'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_COMISION' =>
        array(
            'id_comision' => 'id_comision',
            'id_anhos' => 'id_anhos',
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'id_tipo_destino' => 'id_tipo_destino',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_fin' => 'fecha_fin',
            'id_area' => 'id_area',
            'id_tipo_comision' => 'id_tipo_comision',
            'id_original' => 'id_original',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'activo' => 'activo',
            'id_jefe' => 'id_jefe',
            'trm' => 'trm',
            'id_tipo_viatico' => 'id_tipo_viatico',
            'cargo_jefe' => 'cargo_jefe'
        )
        ,
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'TIPOS_COMISION' =>
        array(
            'descripcion' => 'tipo_comision'
        ),
        'AREA' =>
        array(
            'descripcion' => 'area'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'descripcion' => 'tipo_destino'
        ),
        'COM_TIPO_VIATICO' =>
        array(
            'descripcion' => 'tipo_viatico'
        ),
        'COM_ESTADO_RAD' =>
        array(
            'radicado' => 'radicado'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'no_comision'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_COMISION' =>
        array(
            'id_comision,a' => array('!=' => array(-1)),
            'id_comision,b' => array('=' => array('id_comision')),
            'id_anhos' => array('=' => array('id_anhos')),
            'id_proyecto' => array('=' => array('id_proyecto')),
            'no_comision' => array('=' => array('no_comision')),
            'fecha_solicitud' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_tipo_destino' => array('=' => array('id_tipo_destino')),
            'id_area' => array('=' => array('id_area')),
            'id_tipo_comision' => array('=' => array('id_tipo_comision')),
            'estado' => array('=' => array('estado')),
            'activo' => array('=' => array('activo')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_comision'; //identificador de la tabla
    protected $id_names = array('id_comision'); //llave primaria
    protected $field_names = array('id_anhos', 'id_proyecto', 'no_comision', 'fecha_solicitud', 'id_tipo_destino',
        'objeto', 'agenda', 'fecha_inicio', 'fecha_fin', 'id_area', 'id_tipo_comision', 'id_original', 'estado',
        'fecha_anulacion', 'motivo_anulacion', 'activo', 'id_jefe', 'cargo_jefe', 'trm', 'id_tipo_viatico'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_COMISION'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_comision'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();
        
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            $anular = $request['anular'];
            $id_comision = $request['id_comision'];
            $fecha_anulacion = $request['fecha_anulacion'];
     
            if($anular == "true") {
                $logger->info("Entra a post-anular");
                //20170530 anulamos los pagos_egreso
                $sql = <<<EOD
update COM_PAGO_EGRESO
set ESTADO = 0, 
  MOTIVO_ANULACION = 'Anulación de comisión',
  FECHA_ANULACION = '$fecha_anulacion'
where id_pago_egreso in (select cpe.id_pago_egreso from com_pago_egreso cpe
join com_cuenta cc on cc.ID_CUENTA=cpe.ID_CUENTA
JOIN com_resolucion cr
ON cc.ID_RESOLUCION =cr.ID_RESOLUCION
where cr.ID_COMISION=$id_comision)
EOD;
                CN_TABLE::executeSQL($sql);
                //20170530 Anulamos la Cuenta
                $sql = <<<EOD
update COM_CUENTA
set ESTADO = 0, 
  MOTIVO_ANULACION = 'Anulación de comisión',
  FECHA_ANULACION = '$fecha_anulacion'
where id_cuenta in (select cc.id_cuenta from 
com_cuenta cc 
JOIN com_resolucion cr
ON cc.ID_RESOLUCION =cr.ID_RESOLUCION
where cr.ID_COMISION=$id_comision)
EOD;
                CN_TABLE::executeSQL($sql);
                
                
                $sql = <<<EOD
update COM_RESOLUCION
set ESTADO = 0, 
  MOTIVO_ANULACION = 'Anulación de comisión',
  FECHA_ANULACION = '$fecha_anulacion'
where ID_COMISION = $id_comision
EOD;
                CN_TABLE::executeSQL($sql);
                
            }
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }
        $this->conn->commit();
        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $request['id_anhos'] = $id_anhos;

            $sql = <<<EOD
select consecutivo from com_consecutivo_comision where id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);
            /*
            * Se crea validacion para nuevo año - 20170116
            */
            if (count($records) > 0) {

                $consecutivo = $records[0]['consecutivo'];

                $request['no_comision'] = $consecutivo;

                $sql = <<<EOD
update com_consecutivo_comision set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;
            }else{
                        $consecutivo = 1;

                        $request['no_comision'] = $consecutivo;

                        $sql = <<<EOD
Insert into com_consecutivo_comision (ID_CONSECUTIVO_COMISION,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;
            }
            $request['estado'] = 1;
            $request['activo'] = 1;


            CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;





        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_comision = $request['id_comision'];
        $anular = $request['anular'];
        $abrir = $request['abrir'];

        //if ($anular == "1" || $anular == 1 || $anular = "null" || $anular == null) {
        if ($anular == "true") {

            $sql = <<<EOD
            select count(tab0.id_cuenta) cantidad 

            from com_cuenta tab0 
            join com_resolucion tab1 ON tab1.id_resolucion = tab0.id_resolucion

            where tab0.ESTADO = 1 and  tab1.id_comision = $id_comision
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];


            if ($cantidad > 0) {

                //$errors['mensaje'] = "La comisión no se puede anular porque ya se registro la Cuenta";
                //$errors['servicio'] = "comision";
            }
            
            //20170530 se quita la validacion para anular comision asi tenga pago
            //se agrega condicion para evitar la anulacion en caso de que existe algun cumplido de la comision
            $sql = <<<EOD
            SELECT cumpli.*
FROM 
com_cumplido cumpli
join com_pago_egreso cpe on cpe.ID_PAGO_EGRESO=cumpli.ID_PAGO_EGRESO
join com_cuenta cc on cc.ID_CUENTA=cpe.ID_CUENTA
JOIN com_resolucion cr
ON cc.ID_RESOLUCION =cr.ID_RESOLUCION
where cr.ID_COMISION= $id_comision
EOD;

            $records = CN_TABLE::executeSQL($sql);
            if(count($records)>0){
                $errors['mensaje'] = "La comisión no se puede anular porque ya existe cumplido para algun pago con egreso de la comisión";
                $errors['servicio'] = "comision";
            }
            
            
            // Se deshabilita esta validación por solicitud del cliente - 20161116
/* 
            //Se coloca validacion por si tiene resolucion activa - 20160902
            $sql = <<<EOD
select count(tab0.id_resolucion) cantidad 

from com_resolucion tab0

where tab0.ESTADO = 1 and  tab0.id_comision = $id_comision 
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];

            if ($cantidad > 0) {

                $errors['mensaje'] = "La comisión no se puede anular porque ya se registro la Resolución";
                $errors['servicio'] = "comision";
            }
 */ 
 
        }

//        if ($abrir == "1" || $abrir == 1 || $abrir = "null" || $abrir == null) {
        if ($abrir == "true") {

            $sql = <<<EOD
            select count(tab0.id_cuenta) cantidad 

            from com_cuenta tab0 
            join com_resolucion tab1 ON tab1.id_resolucion = tab0.id_resolucion

            where tab0.ESTADO = 1 and  tab1.id_comision = $id_comision
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];


            if ($cantidad > 0) {
                //20170530 Se permite abrir para cambios de fecha segun solicitud
                //$errors['mensaje'] = "La comisión no se puede abrir porque ya se registro la Cuenta";
                //$errors['servicio'] = "comision";
            }

            //Se coloca validacion por si tiene resolucion activa - 20160902
            //Incidente #4414 - 20160902 
            $sql = <<<EOD
select count(tab0.id_resolucion) cantidad 

from com_resolucion tab0

where tab0.ESTADO = 1 and  tab0.id_comision = $id_comision 
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];

            if ($cantidad > 0) {

                //$errors['mensaje'] = "La comisión no se puede abrir porque ya se registro la Resolución";
                //$errors['servicio'] = "comision";
            }
        }



        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
